package top.octopusyan.utils;

import javafx.beans.property.SimpleBooleanProperty;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.property.SimpleListProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import top.octopusyan.http.request.ProxySetup;

import java.util.List;

/**
 * @author : octopus yan
 * @email : octopus_yan@foxmail.com
 * @description :  应用信息
 * @create : 2022-4-4 17:22
 */
public class ApplicatonStore {
    private static SimpleStringProperty account = new SimpleStringProperty();
    private static SimpleStringProperty password = new SimpleStringProperty();
    private static SimpleStringProperty email = new SimpleStringProperty();
    private static SimpleStringProperty sendMailCode = new SimpleStringProperty();
    private static SimpleBooleanProperty autoLogin = new SimpleBooleanProperty();
    private static SimpleBooleanProperty rememberMe = new SimpleBooleanProperty();
    private static SimpleBooleanProperty registerSuccess = new SimpleBooleanProperty();
    private static SimpleListProperty<ProxySetup> proxyList = new SimpleListProperty<>();
    private static SimpleIntegerProperty selectProxy = new SimpleIntegerProperty(0);

    public static void setAccount(String account) {
        ApplicatonStore.account.set(account);
    }

    public static void setEmail(String email) {
        ApplicatonStore.email.set(email);
    }

    public static void setPassword(String password) {
        ApplicatonStore.password.set(password);
    }

    public static void setSendMailCode(String sendMailCode) {
        ApplicatonStore.sendMailCode.set(sendMailCode);
    }

    public static String getAccount() {
        return account.get();
    }

    public static String getEmail() {
        return email.get();
    }

    public static String getPassword() {
        return password.get();
    }

    public static String getSendMailCode() {
        return sendMailCode.get();
    }

    public static void setAutoLogin(boolean autoLogin) {
        ApplicatonStore.autoLogin.set(autoLogin);
    }

    public static void setRememberMe(boolean rememberMe) {
        ApplicatonStore.rememberMe.set(rememberMe);
    }

    public static boolean isAutoLogin() {
        return autoLogin.get();
    }

    public static boolean isRememberMe() {
        return rememberMe.get();
    }

    public static void setRegisterSuccess(boolean registerSuccess) {
        ApplicatonStore.registerSuccess.set(registerSuccess);
    }

    public static boolean isRegisterSuccess() {
        return registerSuccess.get();
    }

    public static ObservableList<ProxySetup> getProxyList() {
        return proxyList.get();
    }

    public static void initProxyList(List<ProxySetup> proxySetupList) {
        ApplicatonStore.proxyList = new SimpleListProperty<>(FXCollections.observableList(proxySetupList));
    }

    public static void setSelectProxy(int selectProxy) {
        ApplicatonStore.selectProxy.set(selectProxy);
    }

    public static int getSelectProxy() {
        return selectProxy.get();
    }
}
